--- gcc-4.0.0.orig/gcc/simplify-rtx.c	7 Apr 2005 08:25:36 -0000	1.230.2.3
+++ gcc-4.0.0/gcc/simplify-rtx.c	24 Apr 2005 22:15:04 -0000	1.230.2.6
@@ -1549,7 +1549,7 @@
 	     have X (if C is 2 in the example above).  But don't make
 	     something more expensive than we had before.  */
 
-	  if (! FLOAT_MODE_P (mode))
+	  if (SCALAR_INT_MODE_P (mode))
 	    {
 	      HOST_WIDE_INT coeff0h = 0, coeff1h = 0;
 	      unsigned HOST_WIDE_INT coeff0l = 1, coeff1l = 1;
@@ -1720,7 +1720,7 @@
 	     have X (if C is 2 in the example above).  But don't make
 	     something more expensive than we had before.  */
 
-	  if (! FLOAT_MODE_P (mode))
+	  if (SCALAR_INT_MODE_P (mode))
 	    {
 	      HOST_WIDE_INT coeff0h = 0, negcoeff1h = -1;
 	      unsigned HOST_WIDE_INT coeff0l = 1, negcoeff1l = -1;
@@ -1921,7 +1921,7 @@
 	  if (((GET_CODE (op0) == NOT && rtx_equal_p (XEXP (op0, 0), op1))
 	       || (GET_CODE (op1) == NOT && rtx_equal_p (XEXP (op1, 0), op0)))
 	      && ! side_effects_p (op0)
-	      && GET_MODE_CLASS (mode) != MODE_CC)
+	      && SCALAR_INT_MODE_P (mode))
 	    return constm1_rtx;
 	  tem = simplify_associative_operation (code, mode, op0, op1);
 	  if (tem)
@@ -1938,7 +1938,7 @@
 	  if (trueop0 == trueop1
 	      && ! side_effects_p (op0)
 	      && GET_MODE_CLASS (mode) != MODE_CC)
-	    return const0_rtx;
+	    return CONST0_RTX (mode);
 
 	  /* Canonicalize XOR of the most significant bit to PLUS.  */
 	  if ((GET_CODE (op1) == CONST_INT
@@ -1962,8 +1962,8 @@
 	  break;
 
 	case AND:
-	  if (trueop1 == const0_rtx && ! side_effects_p (op0))
-	    return const0_rtx;
+	  if (trueop1 == CONST0_RTX (mode) && ! side_effects_p (op0))
+	    return trueop1;
 	  /* If we are turning off bits already known off in OP0, we need
 	     not do an AND.  */
 	  if (GET_CODE (trueop1) == CONST_INT
@@ -1978,7 +1978,7 @@
 	       || (GET_CODE (op1) == NOT && rtx_equal_p (XEXP (op1, 0), op0)))
 	      && ! side_effects_p (op0)
 	      && GET_MODE_CLASS (mode) != MODE_CC)
-	    return const0_rtx;
+	    return CONST0_RTX (mode);
 
 	  /* Transform (and (extend X) C) into (zero_extend (and X C)) if
 	     there are no nonzero bits of C outside of X's mode.  */
@@ -2049,12 +2049,14 @@
 
 	case UDIV:
 	  /* 0/x is 0 (or x&0 if x has side-effects).  */
-	  if (trueop0 == const0_rtx)
-	    return side_effects_p (op1)
-		   ? simplify_gen_binary (AND, mode, op1, const0_rtx)
-		   : const0_rtx;
+	  if (trueop0 == CONST0_RTX (mode))
+	    {
+	      if (side_effects_p (op1))
+		return simplify_gen_binary (AND, mode, op1, trueop0);
+	      return trueop0;
+	    }
 	  /* x/1 is x.  */
-	  if (trueop1 == const1_rtx)
+	  if (trueop1 == CONST1_RTX (mode))
 	    {
 	      /* Handle narrowing UDIV.  */
 	      rtx x = gen_lowpart_common (mode, op0);
@@ -2113,12 +2115,14 @@
 	  else
 	    {
 	      /* 0/x is 0 (or x&0 if x has side-effects).  */
-	      if (trueop0 == const0_rtx)
-		return side_effects_p (op1)
-		       ? simplify_gen_binary (AND, mode, op1, const0_rtx)
-		       : const0_rtx;
+	      if (trueop0 == CONST0_RTX (mode))
+		{
+		  if (side_effects_p (op1))
+		    return simplify_gen_binary (AND, mode, op1, trueop0);
+		  return trueop0;
+		}
 	      /* x/1 is x.  */
-	      if (trueop1 == const1_rtx)
+	      if (trueop1 == CONST1_RTX (mode))
 		{
 		  /* Handle narrowing DIV.  */
 		  rtx x = gen_lowpart_common (mode, op0);
@@ -2142,15 +2146,19 @@
 
 	case UMOD:
 	  /* 0%x is 0 (or x&0 if x has side-effects).  */
-	  if (trueop0 == const0_rtx)
-	    return side_effects_p (op1)
-		   ? simplify_gen_binary (AND, mode, op1, const0_rtx)
-		   : const0_rtx;
+	  if (trueop0 == CONST0_RTX (mode))
+	    {
+	      if (side_effects_p (op1))
+		return simplify_gen_binary (AND, mode, op1, trueop0);
+	      return trueop0;
+	    }
 	  /* x%1 is 0 (of x&0 if x has side-effects).  */
-	  if (trueop1 == const1_rtx)
-	    return side_effects_p (op0)
-		   ? simplify_gen_binary (AND, mode, op0, const0_rtx)
-		   : const0_rtx;
+	  if (trueop1 == CONST1_RTX (mode))
+	    {
+	      if (side_effects_p (op0))
+		return simplify_gen_binary (AND, mode, op0, CONST0_RTX (mode));
+	      return CONST0_RTX (mode);
+	    }
 	  /* Implement modulus by power of two as AND.  */
 	  if (GET_CODE (trueop1) == CONST_INT
 	      && exact_log2 (INTVAL (trueop1)) > 0)
@@ -2160,15 +2168,19 @@
 
 	case MOD:
 	  /* 0%x is 0 (or x&0 if x has side-effects).  */
-	  if (trueop0 == const0_rtx)
-	    return side_effects_p (op1)
-		   ? simplify_gen_binary (AND, mode, op1, const0_rtx)
-		   : const0_rtx;
+	  if (trueop0 == CONST0_RTX (mode))
+	    {
+	      if (side_effects_p (op1))
+		return simplify_gen_binary (AND, mode, op1, trueop0);
+	      return trueop0;
+	    }
 	  /* x%1 and x%-1 is 0 (or x&0 if x has side-effects).  */
-	  if (trueop1 == const1_rtx || trueop1 == constm1_rtx)
-	    return side_effects_p (op0)
-		   ? simplify_gen_binary (AND, mode, op0, const0_rtx)
-		   : const0_rtx;
+	  if (trueop1 == CONST1_RTX (mode) || trueop1 == constm1_rtx)
+	    {
+	      if (side_effects_p (op0))
+		return simplify_gen_binary (AND, mode, op0, CONST0_RTX (mode));
+	      return CONST0_RTX (mode);
+	    }
 	  break;
 
 	case ROTATERT:
@@ -2184,9 +2196,9 @@
 
 	case ASHIFT:
 	case LSHIFTRT:
-	  if (trueop1 == const0_rtx)
+	  if (trueop1 == CONST0_RTX (mode))
 	    return op0;
-	  if (trueop0 == const0_rtx && ! side_effects_p (op1))
+	  if (trueop0 == CONST0_RTX (mode) && ! side_effects_p (op1))
 	    return op0;
 	  break;
 
@@ -2218,7 +2230,7 @@
 	  break;
 
 	case UMIN:
-	  if (trueop1 == const0_rtx && ! side_effects_p (op0))
+	  if (trueop1 == CONST0_RTX (mode) && ! side_effects_p (op0))
 	    return op1;
 	  if (rtx_equal_p (trueop0, trueop1) && ! side_effects_p (op0))
 	    return op0;
--- gcc-4.0.0.orig/gcc/system.h	23 Feb 2005 23:11:06 -0000	1.245
+++ gcc-4.0.0/gcc/system.h	24 Apr 2005 22:53:47 -0000	1.245.2.1
@@ -46,6 +46,11 @@
 #define NULL 0
 #endif
 
+/* Use the unlocked open routines from libiberty.  */
+#define fopen(PATH,MODE) fopen_unlocked(PATH,MODE)
+#define fdopen(FILDES,MODE) fdopen_unlocked(FILDES,MODE)
+#define freopen(PATH,MODE,STREAM) freopen_unlocked(PATH,MODE,STREAM)
+
 /* The compiler is not a multi-threaded application and therefore we
    do not have to use the locking functions.  In fact, using the locking
    functions can cause the compiler to be significantly slower under
@@ -65,11 +70,65 @@
 #  undef putc
 #  define putc(C, Stream) putc_unlocked (C, Stream)
 # endif
+# ifdef HAVE_PUTCHAR_UNLOCKED
+#  undef putchar
+#  define putchar(C) putchar_unlocked (C)
+# endif
+# ifdef HAVE_GETC_UNLOCKED
+#  undef getc
+#  define getc(Stream) getc_unlocked (Stream)
+# endif
+# ifdef HAVE_GETCHAR_UNLOCKED
+#  undef getchar
+#  define getchar() getchar_unlocked ()
+# endif
 # ifdef HAVE_FPUTC_UNLOCKED
 #  undef fputc
 #  define fputc(C, Stream) fputc_unlocked (C, Stream)
 # endif
 
+# ifdef HAVE_CLEARERR_UNLOCKED
+#  undef clearerr
+#  define clearerr(Stream) clearerr_unlocked (Stream)
+#  if defined (HAVE_DECL_CLEARERR_UNLOCKED) && !HAVE_DECL_CLEARERR_UNLOCKED
+extern void clearerr_unlocked (FILE *);
+#  endif
+# endif
+# ifdef HAVE_FEOF_UNLOCKED
+#  undef feof
+#  define feof(Stream) feof_unlocked (Stream)
+#  if defined (HAVE_DECL_FEOF_UNLOCKED) && !HAVE_DECL_FEOF_UNLOCKED
+extern int feof_unlocked (FILE *);
+#  endif
+# endif
+# ifdef HAVE_FILENO_UNLOCKED
+#  undef fileno
+#  define fileno(Stream) fileno_unlocked (Stream)
+#  if defined (HAVE_DECL_FILENO_UNLOCKED) && !HAVE_DECL_FILENO_UNLOCKED
+extern int fileno_unlocked (FILE *);
+#  endif
+# endif
+# ifdef HAVE_FFLUSH_UNLOCKED
+#  undef fflush
+#  define fflush(Stream) fflush_unlocked (Stream)
+#  if defined (HAVE_DECL_FFLUSH_UNLOCKED) && !HAVE_DECL_FFLUSH_UNLOCKED
+extern int fflush_unlocked (FILE *);
+#  endif
+# endif
+# ifdef HAVE_FGETC_UNLOCKED
+#  undef fgetc
+#  define fgetc(Stream) fgetc_unlocked (Stream)
+#  if defined (HAVE_DECL_FGETC_UNLOCKED) && !HAVE_DECL_FGETC_UNLOCKED
+extern int fgetc_unlocked (FILE *);
+#  endif
+# endif
+# ifdef HAVE_FGETS_UNLOCKED
+#  undef fgets
+#  define fgets(S, n, Stream) fgets_unlocked (S, n, Stream)
+#  if defined (HAVE_DECL_FGETS_UNLOCKED) && !HAVE_DECL_FGETS_UNLOCKED
+extern char *fgets_unlocked (char *, int, FILE *);
+#  endif
+# endif
 # ifdef HAVE_FPUTS_UNLOCKED
 #  undef fputs
 #  define fputs(String, Stream) fputs_unlocked (String, Stream)
@@ -77,11 +136,25 @@
 extern int fputs_unlocked (const char *, FILE *);
 #  endif
 # endif
+# ifdef HAVE_FERROR_UNLOCKED
+#  undef ferror
+#  define ferror(Stream) ferror_unlocked (Stream)
+#  if defined (HAVE_DECL_FERROR_UNLOCKED) && !HAVE_DECL_FERROR_UNLOCKED
+extern int ferror_unlocked (FILE *);
+#  endif
+# endif
+# ifdef HAVE_FREAD_UNLOCKED
+#  undef fread
+#  define fread(Ptr, Size, N, Stream) fread_unlocked (Ptr, Size, N, Stream)
+#  if defined (HAVE_DECL_FREAD_UNLOCKED) && !HAVE_DECL_FREAD_UNLOCKED
+extern size_t fread_unlocked (void *, size_t, size_t, FILE *);
+#  endif
+# endif
 # ifdef HAVE_FWRITE_UNLOCKED
 #  undef fwrite
 #  define fwrite(Ptr, Size, N, Stream) fwrite_unlocked (Ptr, Size, N, Stream)
 #  if defined (HAVE_DECL_FWRITE_UNLOCKED) && !HAVE_DECL_FWRITE_UNLOCKED
-extern int fwrite_unlocked (const void *, size_t, size_t, FILE *);
+extern size_t fwrite_unlocked (const void *, size_t, size_t, FILE *);
 #  endif
 # endif
 # ifdef HAVE_FPRINTF_UNLOCKED
--- gcc-4.0.0.orig/gcc/toplev.c	29 Mar 2005 15:40:43 -0000	1.944.2.2
+++ gcc-4.0.0/gcc/toplev.c	26 Apr 2005 00:30:16 -0000	1.944.2.4
@@ -1602,6 +1602,9 @@
 
   hex_init ();
 
+  /* Unlock the stdio streams.  */
+  unlock_std_streams ();
+
   gcc_init_libintl ();
 
   /* Initialize the diagnostics reporting machinery, so option parsing
--- gcc-4.0.0.orig/gcc/tree-ssa-ccp.c	19 Apr 2005 05:52:26 -0000	2.58.2.1
+++ gcc-4.0.0/gcc/tree-ssa-ccp.c	24 Apr 2005 12:46:06 -0000	2.58.2.2
@@ -2090,18 +2090,6 @@
 
 	      t = TREE_TYPE (TREE_TYPE (OBJ_TYPE_REF_OBJECT (callee)));
 	      t = lang_hooks.fold_obj_type_ref (callee, t);
-	      if (t && TREE_CODE (t) == ADDR_EXPR
-		  && TREE_CODE (TREE_OPERAND (t, 0)) == FUNCTION_DECL
-		  && cgraph_global_info_ready)
-		{
-		  /* If the method has been already finalized as unreachable,
-		     avoid any new references to it.  */
-		  struct cgraph_node *node;
-
-		  node = cgraph_node (TREE_OPERAND (t, 0));
-		  if (!node->reachable && node->local.finalized)
-		    t = NULL_TREE;
-		}
 	      if (t)
 		{
 		  TREE_OPERAND (rhs, 0) = t;
--- gcc-4.0.0.orig/gcc/tree-ssa-pre.c	17 Apr 2005 23:40:31 -0000	2.65.4.2
+++ gcc-4.0.0/gcc/tree-ssa-pre.c	25 Apr 2005 14:02:31 -0000	2.65.4.3
@@ -1330,7 +1330,8 @@
 	
 	folded = fold (build (TREE_CODE (expr), TREE_TYPE (expr), 
 			      genop1, genop2));
-	newexpr = force_gimple_operand (folded, &forced_stmts, false, NULL);
+	newexpr = force_gimple_operand (unshare_expr (folded), 
+					&forced_stmts, false, NULL);
 	if (forced_stmts)
 	  {
 	    tsi = tsi_start (forced_stmts);
@@ -1372,14 +1373,8 @@
 	add_referenced_tmp_var (temp);
 	folded = fold (build (TREE_CODE (expr), TREE_TYPE (expr), 
 			      genop1));
-	/* If the generated operand  is already GIMPLE min_invariant
-	   just use it instead of calling force_gimple_operand on it,
-	   since that may make it not invariant by copying it into an
-	   assignment.  */
-	if (!is_gimple_min_invariant (genop1))
-	  newexpr = force_gimple_operand (folded, &forced_stmts, false, NULL);
-	else
-	  newexpr = genop1;
+	newexpr = force_gimple_operand (unshare_expr (folded), 
+					&forced_stmts, false, NULL);
 	if (forced_stmts)
 	  {
 	    tsi = tsi_start (forced_stmts);
--- gcc-4.0.0.orig/gcc/varasm.c	1 Apr 2005 12:41:10 -0000	1.477.6.7
+++ gcc-4.0.0/gcc/varasm.c	24 Apr 2005 12:46:06 -0000	1.477.6.9
@@ -1884,9 +1884,15 @@
 {
   if (TREE_CODE (decl) == FUNCTION_DECL)
     {
-      /* Extern inline functions don't become needed when referenced.  */
-      if (!DECL_EXTERNAL (decl))
-        cgraph_mark_needed_node (cgraph_node (decl));
+      /* Extern inline functions don't become needed when referenced.
+	 If we know a method will be emitted in other TU and no new
+	 functions can be marked reachable, just use the external
+	 definition.  */
+      struct cgraph_node *node = cgraph_node (decl);
+      if (!DECL_EXTERNAL (decl)
+	  && (!node->local.vtable_method || !cgraph_global_info_ready
+	      || !node->local.finalized))
+	cgraph_mark_needed_node (node);
     }
   else if (TREE_CODE (decl) == VAR_DECL)
     cgraph_varpool_mark_needed_node (cgraph_varpool_node (decl));
@@ -4417,6 +4423,9 @@
 static void
 do_assemble_alias (tree decl, tree target)
 {
+  if (TREE_ASM_WRITTEN (decl))
+    return;
+
   TREE_ASM_WRITTEN (decl) = 1;
   TREE_ASM_WRITTEN (DECL_ASSEMBLER_NAME (decl)) = 1;
 
--- gcc-4.0.0.orig/gcc/ada/ChangeLog	21 Apr 2005 05:17:36 -0000	1.638.4.13
+++ gcc-4.0.0/gcc/ada/ChangeLog	24 Apr 2005 19:21:53 -0000	1.638.4.14
@@ -1,3 +1,9 @@
+2005-04-24  Laurent GUERBY  <laurent@guerby.net>
+
+	PR ada/18847
+	* a-nudira.adb (Value): Check for valid string.
+	* a-nuflra.adb (Value): Likewise.
+	
 2005-04-20  Release Manager
 
 	* GCC 4.0.0 released.
--- gcc-4.0.0.orig/gcc/ada/a-nudira.adb	21 Oct 2003 13:41:53 -0000	1.5
+++ gcc-4.0.0/gcc/ada/a-nudira.adb	24 Apr 2005 19:21:56 -0000	1.5.70.1
@@ -229,25 +229,34 @@
    -----------
 
    function Value (Coded_State : String) return State is
+      Last  : constant Natural := Coded_State'Last;
       Start : Positive := Coded_State'First;
       Stop  : Positive := Coded_State'First;
       Outs  : State;
 
    begin
-      while Coded_State (Stop) /= ',' loop
+      while Stop <= Last and then Coded_State (Stop) /= ',' loop
          Stop := Stop + 1;
       end loop;
 
+      if Stop > Last then
+         raise Constraint_Error;
+      end if;
+
       Outs.X1 := Int'Value (Coded_State (Start .. Stop - 1));
       Start := Stop + 1;
 
       loop
          Stop := Stop + 1;
-         exit when Coded_State (Stop) = ',';
+         exit when Stop > Last or else Coded_State (Stop) = ',';
       end loop;
 
+      if Stop > Last then
+         raise Constraint_Error;
+      end if;
+
       Outs.X2  := Int'Value (Coded_State (Start .. Stop - 1));
-      Outs.Q   := Int'Value (Coded_State (Stop + 1 .. Coded_State'Last));
+      Outs.Q   := Int'Value (Coded_State (Stop + 1 .. Last));
       Outs.P   := Outs.Q * 2 + 1;
       Outs.FP  := Flt (Outs.P);
       Outs.Scl := (RstL - RstF + 1.0) / (Flt (Outs.P) * Flt (Outs.Q));
--- gcc-4.0.0.orig/gcc/ada/a-nuflra.adb	21 Oct 2003 13:41:53 -0000	1.5
+++ gcc-4.0.0/gcc/ada/a-nuflra.adb	24 Apr 2005 19:21:56 -0000	1.5.70.1
@@ -256,33 +256,46 @@
    -----------
 
    function Value (Coded_State : String) return State is
+      Last  : constant Natural := Coded_State'Last;
       Start : Positive := Coded_State'First;
       Stop  : Positive := Coded_State'First;
       Outs  : State;
 
    begin
-      while Coded_State (Stop) /= ',' loop
+      while Stop <= Last and then Coded_State (Stop) /= ',' loop
          Stop := Stop + 1;
       end loop;
 
+      if Stop > Last then
+         raise Constraint_Error;
+      end if;
+
       Outs.X1 := Int'Value (Coded_State (Start .. Stop - 1));
       Start := Stop + 1;
 
       loop
          Stop := Stop + 1;
-         exit when Coded_State (Stop) = ',';
+         exit when Stop > Last or else Coded_State (Stop) = ',';
       end loop;
 
+      if Stop > Last then
+         raise Constraint_Error;
+      end if;
+
       Outs.X2 := Int'Value (Coded_State (Start .. Stop - 1));
       Start := Stop + 1;
 
       loop
          Stop := Stop + 1;
-         exit when Coded_State (Stop) = ',';
+         exit when Stop > Last or else Coded_State (Stop) = ',';
       end loop;
 
+      if Stop > Last then
+         raise Constraint_Error;
+      end if;
+
       Outs.P   := Int'Value (Coded_State (Start .. Stop - 1));
-      Outs.Q   := Int'Value (Coded_State (Stop + 1 .. Coded_State'Last));
+      Outs.Q   := Int'Value (Coded_State (Stop + 1 .. Last));
       Outs.X   := Euclid (Outs.P, Outs.Q);
       Outs.Scl := 1.0 / (Flt (Outs.P) * Flt (Outs.Q));
 
--- gcc-4.0.0.orig/gcc/config/freebsd-spec.h	23 Jan 2005 15:05:37 -0000	1.13
+++ gcc-4.0.0/gcc/config/freebsd-spec.h	1 May 2005 18:59:27 -0000	1.13.8.1
@@ -78,6 +78,7 @@
 
 #define FBSD_CPP_SPEC "							\
   %(cpp_cpu)								\
+  %(cpp_arch)								\
   %{fPIC|fpic|fPIE|fpie:-D__PIC__ -D__pic__}				\
   %{posix:-D_POSIX_SOURCE}"
 
--- gcc-4.0.0.orig/gcc/config/rtems.h	5 Jul 2004 19:49:14 -0000	1.6
+++ gcc-4.0.0/gcc/config/rtems.h	2 May 2005 04:36:43 -0000
@@ -19,6 +19,7 @@
 Boston, MA 02111-1307, USA.  */
 
 /* The system headers under RTEMS are C++-aware.  */
+#undef NO_IMPLICIT_EXTERN_C
 #define NO_IMPLICIT_EXTERN_C
 
 /*
--- gcc-4.0.0.orig/gcc/config/arm/bpabi.h	12 Oct 2004 14:09:41 -0000	1.8
+++ gcc-4.0.0/gcc/config/arm/bpabi.h	30 Apr 2005 19:41:25 -0000	1.8.24.1
@@ -46,7 +46,7 @@
   "%{static:-Bstatic} %{shared:-shared} %{symbolic:-Bsymbolic} "	\
   "-X"
 
-#if defined (__thumb__) && !defined (__THUMB_INTERWORK__) 
+#if defined (__thumb__)
 #define RENAME_LIBRARY_SET ".thumb_set"
 #else
 #define RENAME_LIBRARY_SET ".set"
--- gcc-4.0.0.orig/gcc/config/arm/ieee754-df.S	27 Oct 2004 20:32:02 -0000	1.9
+++ gcc-4.0.0/gcc/config/arm/ieee754-df.S	30 Apr 2005 19:41:25 -0000	1.9.18.1
@@ -81,7 +81,7 @@
 ARM_FUNC_ALIAS aeabi_dsub subdf3
 
 	eor	yh, yh, #0x80000000	@ flip sign bit of second arg
-#if defined(__thumb__) && !defined(__THUMB_INTERWORK__)
+#if defined(__INTERWORKING_STUBS__)
 	b	1f			@ Skip Thumb-code prologue
 #endif
 
--- gcc-4.0.0.orig/gcc/config/arm/ieee754-sf.S	18 Dec 2004 18:45:35 -0000	1.9
+++ gcc-4.0.0/gcc/config/arm/ieee754-sf.S	30 Apr 2005 19:41:25 -0000	1.9.10.1
@@ -62,7 +62,7 @@
 ARM_FUNC_ALIAS aeabi_fsub subsf3
 
 	eor	r1, r1, #0x80000000	@ flip sign bit of second arg
-#if defined(__thumb__) && !defined(__THUMB_INTERWORK__)
+#if defined(__INTERWORKING_STUBS__)
 	b	1f			@ Skip Thumb-code prologue
 #endif
 
--- gcc-4.0.0.orig/gcc/config/arm/lib1funcs.asm	21 Feb 2005 14:39:52 -0000	1.38
+++ gcc-4.0.0/gcc/config/arm/lib1funcs.asm	30 Apr 2005 19:41:25 -0000	1.38.2.1
@@ -94,10 +94,20 @@
 # define RET		bx	lr
 # define RETc(x)	bx##x	lr
 
-# if (__ARM_ARCH__ == 4) \
-	&& (defined(__thumb__) || defined(__THUMB_INTERWORK__))
-#  define __INTERWORKING__
-# endif
+/* Special precautions for interworking on armv4t.  */
+# if (__ARM_ARCH__ == 4)
+
+/* Always use bx, not ldr pc.  */
+#  if (defined(__thumb__) || defined(__THUMB_INTERWORK__))
+#    define __INTERWORKING__
+#   endif /* __THUMB__ || __THUMB_INTERWORK__ */
+
+/* Include thumb stub before arm mode code.  */
+#  if defined(__thumb__) && !defined(__THUMB_INTERWORK__)
+#   define __INTERWORKING_STUBS__
+#  endif /* __thumb__ && !__THUMB_INTERWORK__ */
+
+#endif /* __ARM_ARCH == 4 */
 
 #else
 
@@ -192,7 +202,7 @@
 /* Special function that will always be coded in ARM assembly, even if
    in Thumb-only compilation.  */
 
-#if defined(__thumb__) && !defined(__THUMB_INTERWORK__)
+#if defined(__INTERWORKING_STUBS__)
 .macro	ARM_FUNC_START name
 	FUNC_START \name
 	bx	pc
@@ -225,13 +235,17 @@
 
 .macro	FUNC_ALIAS new old
 	.globl	SYM (__\new)
-	EQUIV	SYM (__\new), SYM (__\old)
+#if defined (__thumb__)
+	.thumb_set	SYM (__\new), SYM (__\old)
+#else
+	.set	SYM (__\new), SYM (__\old)
+#endif
 .endm
 
 .macro	ARM_FUNC_ALIAS new old
 	.globl	SYM (__\new)
 	EQUIV	SYM (__\new), SYM (__\old)
-#ifdef __thumb__
+#if defined(__INTERWORKING_STUBS__)
 	.set	SYM (_L__\new), SYM (_L__\old)
 #endif
 .endm
--- gcc-4.0.0.orig/gcc/config/avr/t-avr	25 Dec 2004 22:20:04 -0000	1.14
+++ gcc-4.0.0/gcc/config/avr/t-avr	25 Apr 2005 04:14:24 -0000	1.14.10.1
@@ -1,7 +1,3 @@
-# Specific names for AVR tools
-AR_FOR_TARGET = avr-ar
-RANLIB_FOR_TARGET = avr-ranlib
-
 LIB1ASMSRC = avr/libgcc.S
 LIB1ASMFUNCS = \
 	_mulqi3 \
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gcc-4.0.0/gcc/config/bfin/bfin-modes.def	25 Apr 2005 10:40:25 -0000	1.1.8.1
@@ -0,0 +1,25 @@
+/* Definitions of target machine for GNU compiler, for Blackfin.
+   Copyright (C) 2005 Free Software Foundation, Inc.
+   Contributed by Analog Devices.
+
+   This file is part of GCC.
+
+   GCC is free software; you can redistribute it and/or modify it
+   under the terms of the GNU General Public License as published
+   by the Free Software Foundation; either version 2, or (at your
+   option) any later version.
+
+   GCC is distributed in the hope that it will be useful, but WITHOUT
+   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
+   License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with GCC; see the file COPYING.  If not, write to the
+   Free Software Foundation, 59 Temple Place - Suite 330, Boston,
+   MA 02111-1307, USA.  */
+
+/* PDImode for the 40 bit accumulators.  */
+PARTIAL_INT_MODE (DI);
+
+VECTOR_MODE (INT, HI, 2); /* V2HI */
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gcc-4.0.0/gcc/config/bfin/bfin-protos.h	25 Apr 2005 10:40:25 -0000	1.1.8.1
@@ -0,0 +1,88 @@
+/* Prototypes for Blackfin functions used in the md file & elsewhere.
+   Copyright (C) 2005 Free Software Foundation, Inc.
+
+   This file is part of GNU CC.
+
+   GNU CC is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   GNU CC is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with GNU CC; see the file COPYING.  If not, write to
+   the Free Software Foundation, 59 Temple Place - Suite 330,
+   Boston, MA 02111-1307, USA.  */
+
+/* Function prototypes that cannot exist in bfin.h due to dependency
+   complications.  */
+#ifndef GCC_BFIN_PROTOS_H
+#define GCC_BFIN_PROTOS_H
+
+#define Mmode enum machine_mode
+
+extern rtx function_arg (CUMULATIVE_ARGS *, Mmode, tree, int);
+extern void function_arg_advance (CUMULATIVE_ARGS *, Mmode, tree, int);
+extern bool function_arg_regno_p (int);
+
+extern const char *output_load_immediate (rtx *);
+extern const char *output_casesi_internal (rtx *);
+extern char *bfin_asm_long (void);
+extern char *bfin_asm_short (void);
+extern int log2constp (unsigned HOST_WIDE_INT);
+
+extern rtx legitimize_address (rtx, rtx, Mmode);
+extern int hard_regno_mode_ok (int, Mmode);
+extern void init_cumulative_args (CUMULATIVE_ARGS *, tree, rtx);	  
+extern int bfin_frame_pointer_required (void);
+extern HOST_WIDE_INT bfin_initial_elimination_offset (int, int);
+
+extern int effective_address_32bit_p (rtx, Mmode);
+extern int symbolic_reference_mentioned_p (rtx);
+extern rtx bfin_gen_compare (rtx, Mmode);
+extern void expand_move (rtx *, Mmode);
+extern void bfin_expand_call (rtx, rtx, rtx, int);
+extern bool bfin_expand_strmov (rtx, rtx, rtx, rtx);
+
+extern void conditional_register_usage (void);
+extern int bfin_register_move_cost (enum machine_mode, enum reg_class,
+				    enum reg_class);
+extern int bfin_memory_move_cost (enum machine_mode, enum reg_class, int in);
+extern enum reg_class secondary_input_reload_class (enum reg_class, Mmode,
+						    rtx);
+extern enum reg_class secondary_output_reload_class (enum reg_class, Mmode,
+						     rtx);
+extern char *section_asm_op_1 (SECT_ENUM_T);
+extern char *section_asm_op (SECT_ENUM_T);
+extern void override_options (void);
+extern void print_operand (FILE *,  rtx, char);
+extern void print_address_operand (FILE *, rtx);
+extern void split_di (rtx [], int, rtx [], rtx []);
+extern int split_load_immediate (rtx []);
+extern rtx legitimize_pic_address (rtx, rtx);
+extern void emit_pic_move (rtx *, Mmode);
+extern void override_options (void);
+extern void asm_conditional_branch (rtx, rtx *, int, int);
+extern rtx bfin_gen_compare (rtx, Mmode);
+
+extern int bfin_return_in_memory (tree);
+extern void initialize_trampoline (rtx, rtx, rtx);
+extern bool bfin_legitimate_address_p (Mmode, rtx, int);
+extern rtx bfin_va_arg (tree, tree);
+
+extern void bfin_expand_prologue (void);
+extern void bfin_expand_epilogue (int, int);
+extern int push_multiple_operation (rtx, Mmode);
+extern int pop_multiple_operation (rtx, Mmode);
+extern void output_push_multiple (rtx, rtx *);
+extern void output_pop_multiple (rtx, rtx *);
+extern int bfin_hard_regno_rename_ok (unsigned int, unsigned int);
+extern rtx bfin_return_addr_rtx (int);
+#undef  Mmode 
+
+#endif
+
